#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

int main(int argc, char** argv)
{
FILE *fptr_in, *fptr_out;
const unsigned int buf_len=16384;
unsigned char buffer[buf_len];
char s[40], sout[40], *sp;
unsigned int ch;
int i, num, bytes_in;
long oflen=1455360, oftmp, total;
char *author="author: Alexey Romanov (aromanov@meceng.coe.neu.edu)";

if(argc<2)
{
 _help:
 fprintf(stderr, "Usage: uusplit filename [maxlen=%ld]\n", oflen);
 fprintf(stderr, "filename -- the file to be split apart\n");
 fprintf(stderr, "maxlen   -- maximum length of output file(s).\n");
 exit(0);
}

if(argc==3)
{
 oflen = atol(argv[2]);
 if(oflen==0) goto _help;
}

fptr_in=fopen(argv[1], "rb");
if(NULL==fptr_in)
 {
  fprintf(stderr, "Error: unable to open '%s'", argv[1]);
  exit(1);
 }
fptr_out=NULL;
strcpy((char*)s, argv[1]);
sp=strchr((char*)s, (int)'.');
if(NULL!=sp) *sp=0;
bytes_in=0;
oftmp=oflen;
num=0;

 while(1)
 {
  if(kbhit()) getch(); /* check keyboard: allows user to terminate with ^C */
  /* fill buffer */
  bytes_in=fread(&buffer, 1, buf_len, fptr_in);
  /* reached eof on input? */
  if(bytes_in==0)
  {
   /* stop */
   fclose(fptr_out);
   break;
  }

  /* flush buffer */
  total=0;
  while( bytes_in>0 )
  {
  i = ((oflen-oftmp)<bytes_in) ? oflen-oftmp : bytes_in;
  if(oflen==oftmp)
   {
    if(fptr_out!=NULL) fclose(fptr_out);
    sprintf((char*)sout, "%s.%c%c", s, 'a'+(num/26), 'a'+(num%26));
    fptr_out=fopen((char*)sout, "wb");
    if(NULL==fptr_out)
     {
      fprintf(stderr, "Error: unable to open '%s'. Too many open files?", sout);
      fcloseall();
      exit(1);
     }
    oftmp=0;
    num++;
    continue;
   }
  if(1 != fwrite( &buffer[total], i, 1, fptr_out ))
   {
   fprintf(stderr, "Error: write failed. Disk full?");
   fcloseall();
   exit(1);
   }
  total += i;
  oftmp += i;
  bytes_in -= i;
  }
 }
 exit(0);
}/*main()*/
