#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

int main(int argc, char** argv){

FILE *fptr_in, *fptr_out;
const int buf_len=16384;
unsigned char buffer[buf_len];
char old_sort[80], current_sort[80];
char ch_in;
int i, bytes_in, found;
char *author="author: Alexey Romanov (aromanov@meceng.coe.neu.edu)";

if(argc<3)
{
 _help:
 fprintf(stderr, "Usage: uujoin input_files ... output_file\n");
 fprintf(stderr, "input_files ... -- files to be joined ( wildcards ?, * - ok)\n");
 exit(0);
}

fptr_out=fopen(argv[argc-1], "rt");
if(NULL!=fptr_out)
 {
  for(i=1; i<argc-1; i++)
  {
  if(strcmpi(argv[argc-1], argv[i])==0)
    { 
    fprintf(stderr, "Error: Cannot use the same '%s' for reading and writing.", argv[argc-1]);
    fclose(fptr_out);
    exit(1);
    }
  }
  fprintf(stderr, "Owerwrite existing %s(Y/N)?", argv[argc-1]);
  ch_in = getch();
  if((ch_in!='y')&&(ch_in!='Y')) 
   {
    fclose(fptr_out);
    exit(1);
   }
  fprintf(stderr, "Yes\n");
 }
fclose(fptr_out);

fptr_out=fopen(argv[argc-1], "wb");
if(NULL==fptr_out)
{
 fprintf(stderr, "Error opening '%s'. Too many open files?", argv[argc-1]);
 exit(1);
}

/* reset */
old_sort[0]=0;
fptr_in=NULL;
bytes_in=0;
found=0;

while(1)
{
 if(kbhit()) getch(); /* check keyboard: allows user to terminate with ^C */
 /* fill buffer */
 while(bytes_in<buf_len)
 {
 if(!found)
  {
   /* pick next file to read from */
   current_sort[0]=255;
   for(i=1; i<argc-1; i++)
    {
     /* sort -- find smallest string */
     if((strcmp(argv[i],old_sort)>0) && (strcmp(argv[i],current_sort)<0))
       { 
	found=1;
	strcpy(current_sort, argv[i]);
       }
    }
   if(!found)
      {
       /* no more files to read */
       fclose(fptr_in);
       break;
      }
   strcpy(old_sort, current_sort);
   if(NULL!=fptr_in) fclose(fptr_in);
   fptr_in=fopen(current_sort, "rb");
   if(NULL==fptr_in) 
   {
    fprintf(stderr, "Error opening '%s'. Too many open files?", current_sort);
    exit(1);
   }
   fprintf(stderr, "%s\n", current_sort);
  }
  if(!found) break; /* no more data */

  i=fread(&buffer[bytes_in], 1, buf_len-bytes_in, fptr_in);
  bytes_in += i;
  if(i < buf_len-bytes_in)
  {
   found=0;
   continue;
  }
 }

  /* flush buffer */
  if(1!=fwrite(&buffer, bytes_in, 1, fptr_out))
  {
    fprintf(stderr, "Error: write failed. Disk full?");
    fcloseall();
    exit(1);
  }
  bytes_in=0;

  if(!found)
  {
  fclose(fptr_out);
  break;
  }
}
exit(0);
}/*main()*/
